<svelte:window on:keydown="globalKeyDown(editing, $modal, event)" />

<div class="input"
     class:picker-open="emojiPicker"
     class:channel-input="isChannelInput"
     class:has-files="!editing && files.length">

  {#if suggestions && suggestions.length}
  <div class="suggestions">
    {#each suggestions as suggestion, index (suggestion[completionIdKey])}
    <div class="suggestion"
         class:selected="index == suggestionIndex"
         on:click="insertSuggestion({suggestionIndex: index, suggestions, completionKey, messageContent})"
         on:mouseover="set({suggestionIndex: index})">
      <div class="suggestion-icon">
        <img src={iconTransform(completionKey, suggestion)}/>
      </div>
      <div class="suggestion-name">
        {humanTransform(completionKey, suggestion)}
      </div>
    </div>
    {/each}
  </div>
  {/if}

  {#if !editing}
  <div class="file-list" class:display="game || files && files.length">
    {#each files as file, index}
    <FilePreview {file} on:remove="deleteFile(files, index)" /> {/each}
    {#if game}
    <GamePreview {game}
                 options={gameOptions}
                 on:remove="set({game: undefined, gameOptions: undefined})" />
    {/if}
  </div>
  {/if}

  <div class="channel-textarea"
       class:editing="editing"
       class:suggesting="suggestions">
    {#if !editing}
    <UploadIcon on:fileAdd="addFile(event, files)"
                on:setGame="set({game: event, gameOptions: undefined})" /> {/if}

    <textarea
      bind:value=messageContent
      class="channel-textarea-native"
      ref:textarea
      on:paste="onPaste(event, files)"
      placeholder="Message #{channelName}"
      on:keydown="onKeyDown(event, editing, {
                    suggestions,
                    suggestionIndex,
                    completionKey,
                    messageContent
                  })"
      on:keypress="checkForSend({
                     files,
                     editing,
                     onSubmit,
                     event,
                     shiftKey: event.shiftKey,
                     code: event.which || event.keyCode,
                     channelId,
                     messageContent,
                     messages,
                     suggestions,
                     suggestionIndex,
                     $guildId,
                     completionKey,
                     game,
                     gameOptions
                   })"
    />
    <EmojiIcon on:click="set({emojiPicker: !emojiPicker})" />
  </div>
  {#if emojiPicker}
  <div class="picker">
    <EmojiPicker
      shape={$emojiShape}
      color={$emojiColor}
      on:insert="insert(messageContent, event)" />
  </div>
  {/if}        
</div>

<script>
  import RestClient from "../js/RestClient";
  import ChannelMessageStore from "../stores/ChannelMessageStore";
  import TokenStore from "../js/TokenStore";
  import SnowflakeUtils from "../js/SnowflakeUtils";
  import UploadIcon from "./UploadIcon.svelte";
  import FilePreview from "./FilePreview.svelte";
  import * as Markup from "../js/Markup";
  import Fuse from "fuse.js";
  import * as MessageMiddlewares from "../js/MessageMiddlewares";
  console.log(SnowflakeUtils, "SFLK");

  export default {
    data() {
      return {
        suggestionIndex: 0
      };
    },
    components: {
      UploadIcon,
      FilePreview,
      EmojiPicker: "./EmojiPicker.svelte",
      EmojiIcon: "./icons/EmojiIcon.svelte",
      GamePreview: "./GamePreview.svelte"
    },
    helpers: {
      humanTransform(key, suggestion) {
        return Markup.completions.get(key).humanTransform(suggestion);
      },
      iconTransform(key, suggestion) {
        return Markup.completions.get(key).iconTransform(suggestion);
      }
    },
    methods: {
      insert(messageContent, inserted) {
        const cursor = this.refs.textarea.selectionStart;

        messageContent =
          messageContent.substring(0, cursor) +
          inserted +
          messageContent.substring(cursor);
        this.set({
          messageContent
        });
      },
      insertSuggestion({
        completionKey,
        suggestionIndex,
        suggestions,
        messageContent
      }) {
        console.log("completionKey?", completionKey);
        const newText = Markup.completions
          .get(completionKey)
          .humanTransform(suggestions[suggestionIndex]);
        const cursor = this.refs.textarea.selectionStart;
        const completionIndex = messageContent
          .substring(0, cursor)
          .lastIndexOf(completionKey);

        const content =
          messageContent.substring(0, completionIndex) +
          newText +
          " " +
          messageContent.substring(cursor);
        this.set({messageContent: content});
        setTimeout(() => {
          this.set({suggestions: undefined, suggestionIndex: 0});
          this._fuse = undefined;
          this.refs.textarea.focus();
        });
      },
      deleteFile(files, index) {
        files.splice(index, 1);
        this.set({files});
      },
      onPaste(event, files) {
        const items = Array.from(
          (event.clipboardData || event.originalEvent.clipboardData).items
        );

        console.log("onPaste()", items, event);

        const newFiles = items.filter(itm => itm.kind == "file");

        if (!newFiles.length) return;
        event.preventDefault();
        this.set({
          files: files.concat(newFiles.map(itm => itm.getAsFile()))
        });
      },
      addFile(file, files) {
        console.log("GOT FILE!", file);
        files.push(file);
        this.set({files});
      },
      globalKeyDown(editing, modal, event) {
        if (editing) return;
        const code = event.which || event.keyCode;
        console.log("GLOBKEYDOWN", code, event.code);
        if (code == 27) {
          this.fire("messageSent");
          this.refs.textarea.focus();
          return;
        }
        // Discord just does this I guess
        const disallowed = ["PageDown", "PageUp", "Home", "End"];
        const disallowedElems = ["TEXTAREA", "INPUT"];
        if (disallowed.includes(event.key)) return;
        if (disallowedElems.includes(event.target.tagname)) return;
        // input elems
        if (event.target.value !== undefined) return;
        if (
          !modal &&
          !event.ctrlKey &&
          !event.metaKey &&
          event.target != this.refs.textarea
        ) {
          this.refs.textarea.focus();
          event.preventDefault();
          if (event.key.length == 1)
            this.refs.textarea.value += event.shiftKey
              ? event.key.toUpperCase()
              : event.key.toLowerCase();
        }
      },

      async checkForSend({
        onSubmit,
        files,
        editing,
        event,
        code,
        messageContent,
        channelId,
        suggestions,
        suggestionIndex,
        completionKey,
        game,
        gameOptions
      }) {
        console.log(onSubmit, "ONSUBM");
        if (code == 13 && !event.shiftKey) event.preventDefault();
        this.refs.textarea.focus();
        if (
          !event.shiftKey &&
          code == 13 &&
          !(suggestions && suggestions.length)
        ) {
          const trimmedRaw = messageContent.trim();
          const trimmedSerialised = Markup.serialise(trimmedRaw, channelId);
          const {
            content: trimmed,
            attachments
          } = await MessageMiddlewares.beforeSend({
            content: trimmedSerialised,
            attachments:
              files &&
              files.map(file => ({
                mime: file.type,
                filename: file.name,
                size: file.size
                // TODO: Image geometry
              }))
          });
          let sendPromise = null;
          if (editing) {
            if (trimmed.length) {
              sendPromise = RestClient.patch(
                `/channels/${channelId}/messages/${editing}`,
                {
                  content: trimmed
                }
              );
            } else {
              sendPromise = RestClient.delete(
                `/channels/${channelId}/messages/${editing}`
              );
            }
          } else if (trimmed.length) {
            // this is super duper unlikely to collide so I think we're safe
            const nonce = await SnowflakeUtils.generateSnowflake();

            ChannelMessageStore._nonces.add(nonce);

            ChannelMessageStore.slurp({
              content: trimmed,
              id: null,
              nonce,
              channelId,
              authorId: await TokenStore.getUserId(),
              attachments: [] // TODO: We ought to add this somehow..
            });
            sendPromise = RestClient.post(`/channels/${channelId}/messages`, {
              content: trimmed,
              nonce,
              attachments,
              gameId: game && game.id,
              gameOptions: gameOptions
            }).then(res => {
              const promises = new Set();
              for (const fileIndex in files) {
                const attachment = res.attachments[fileIndex];
                promises.add(
                  RestClient.put(
                    `/channels/${channelId}/messages/${res.id}/${attachment.id}`,
                    files[fileIndex]
                  )
                );
              }
              // We do this all concurrently, so we can show it as 'sent'
              Promise.all(promises.values());
              return res;
            });
          }
          if (sendPromise) {
            this.set({
              sending: true,
              files: [],
              game: undefined,
              gameOptions: undefined
            });
            // this.fire("messageSent");
            if (editing) this.fire("edit", null);
            else this.set({messageContent: ""});
            try {
              const messageFormat = await sendPromise;
              if (editing && !trimmed.length)
                ChannelMessageStore.unslurp({id: editing});
              else ChannelMessageStore.slurp(messageFormat);
            } catch (err) {
              // TODO: Red error text thing?
              console.error(err);
            }
            this.fire("messageSent");
            this.set({sending: false});
            if (this.refs.textarea) this.refs.textarea.focus();
          }
        } else if (code == 13 && suggestions && suggestions.length) {
          console.log("Inserting suggestion!", code, suggestions);
          // Insert the suggestion
          this.insertSuggestion({
            suggestions,
            completionKey,
            suggestionIndex,
            messageContent
          });
        }
      },
      onKeyDown(
        event,
        editing,
        {suggestions, suggestionIndex, completionKey, messageContent} = {}
      ) {
        if (event) {
          const code = event.which || event.keyCode;
          if (code == 33 || code == 34) event.preventDefault();
          console.log("channelinput code", code);
          // Up arrow, start editing
          if (
            code == 38 &&
            !event.altKey &&
            !editing &&
            !(suggestions && suggestions.length) &&
            this.refs.textarea &&
            this.refs.textarea.selectionStart == 0
          ) {
            const got = this.get();
            const lastOwnMessageId = got.lastOwnMessageId;
            if (lastOwnMessageId) {
              this.fire("edit", lastOwnMessageId);
              if (got.messages[got.messages.length - 1].id == lastOwnMessageId) {
                console.log("wanting for a jump!");
                this.fire("stickToBottom");
              }
            }
            // Escape
          } else if (code == 27 && editing) {
            this.fire("edit", null);
          } else if (code == 40 && suggestions && suggestions.length) {
            if (suggestionIndex != suggestions.length - 1) {
              suggestionIndex++;
            } else suggestionIndex = 0;
            this.set({suggestionIndex});
            event.preventDefault();
          } else if (code == 38 && suggestions && suggestions.length) {
            if (suggestionIndex != 0) {
              suggestionIndex--;
            } else suggestionIndex = suggestions.length - 1;
            this.set({suggestionIndex});
            event.preventDefault();
          } else if (code == 9 && suggestions && suggestions.length) {
            console.log("Inserting suggestion!", code, suggestions);
            // Insert the suggestion
            this.insertSuggestion({
              suggestions,
              completionKey,
              suggestionIndex,
              messageContent
            });
            event.preventDefault();
          }
        }
      }
    },
    onupdate({changed}) {
      if (changed.messageContent && this.refs.textarea) {
        const maxHeight = 141;
        this.refs.textarea.style.height = 0;
        const calculatedHeight = this.refs.textarea.scrollHeight;
        console.log("calculatedHeight", calculatedHeight);
        this.refs.textarea.style.height =
          (calculatedHeight > maxHeight ? maxHeight : calculatedHeight) + "px";
        this.fire("stickToBottom");
      }
    },
    onstate({current, changed, previous}) {
      if (changed.game && !changed.gameOptions && previous.gameOptions) {
        this.set({
          gameOptions: undefined
        });
      }
      if (changed.editing && current.editing) {
        setTimeout(() => {
          this.refs.textarea.selectionStart = this.refs.textarea.selectionEnd =
            Number.MAX_SAFE_INTEGER;
        });
      }
      if (changed.channelId && current.channelId && this.refs.textarea) {
        this.refs.textarea.focus();
      }
      if (changed.suggestions) {
        if (
          current.suggestions &&
          current.suggestions.length >= current.suggestionIndex
        ) {
          this.set({suggestionIndex: 0});
        } else if (!current.suggestions) {
          this._fuse = null;
        }
      }
      if (
        changed.messageContent &&
        this.refs.textarea &&
        current.messageContent &&
        current.messageContent.length
      ) {
        const typingLocation = this.refs.textarea.selectionStart;
        let queryArr = [];
        console.log("MESSAGECONTENT CHNAGED, GENERATING SUGGESTIONS");
        let found = false;
        let keepFuse = false;
        for (let i = typingLocation - 1; i !== -1; i--) {
          const content = current.messageContent[i];
          // console.log("Traversing inwards", i, content);
          // Autocompletions can't span spaces, so we're faster!
          if (content == " " || content == "\n" || content == "/") {
            break;
          }
          const completion = Markup.completions.get(content);
          if (completion) {
            console.log("Found a completion");
            if (this._fuse && this._fuse.isLarge && queryArr.length < 2) {
              console.log("Too large to search at this queryArr len!");
              break;
            }
            found = true;
            if (!this._fuse || this._fuse.completionKey != content) {
              console.log("FUsing!");
              const items = completion.getItems({
                guildId: this.store.get().guildId,
                channelId: current.channelId
              });
              const large = items.length > 100;
              // I can't wait for cached fuse inconsistencies with store :)
              this._fuse = new Fuse(items, {
                shouldSort: true,
                threshold: 0.6,
                location: 0,
                distance: 100,
                maxPatternLength: 32,
                minMatchCharLength: large ? 2 : 1,
                keys: [completion.nameKey || "name"]
              });
              console.log("completionKey", content);
              this.set({
                completionKey: content,
                completionIdKey: completion.idKey || "id"
              });
              this._fuse.completionKey = content;
              this._fuse.isLarge = large;
            }
            if (this._fuse.isLarge && queryArr.length < 2) {
              keepFuse = true;
              break;
            }
            if (queryArr.length == 0) {
              console.log("len0");
              this.set({suggestions: this._fuse.list.slice(0, 9)});
            } else {
              const query = queryArr.join("");
              console.log("SEARCHING FUSE", query, this._fuse);
              const newSuggestions = this._fuse.search(query).slice(0, 9);
              console.log(newSuggestions);
              this.set({suggestions: newSuggestions});
            }
            break;
          } else queryArr.unshift(content);
        }
        if (!found) {
          if (current.suggestions)
            this.set({suggestions: undefined, suggestionIndex: 0});
          if (this._fuse && !keepFuse) this._fuse = undefined;
        }
      } else if (!current.messageContent && changed.messageContent) {
        if (this._fuse) this._fuse = undefined;
        this.set({
          suggestions: undefined,
          suggestionIndex: 0
        });
      }
    },
    oncreate() {
      window.channelInput = this;
      this.refs.textarea.focus();
      this.onKeyDown();
    }
  };
</script>

<style>
  .channel-textarea {
    width: calc(100% - 32px - 48px);
    background-color: #2f3336;
    color: #fff;
    border: none;
    border-radius: 5px;

    margin: 1.5em;
    margin-top: 0.4rem;
    padding: 0.55rem 1rem;
    padding-left: 0.8rem;
    padding-bottom: 0.275rem;
    font-family: Roboto, sans-serif;
  }

  .channel-textarea-native:focus {
    outline: none;
  }

  .file-list.display {
    padding: 0.25em 0.4em;
    background-color: #101112;
  }

  .channel-textarea.editing {
    margin-left: 0;
    margin-right: 0;
  }

  .editing .channel-textarea-native {
    width: calc(100% - 32px);
  }

  .channel-textarea-native {
    background: none;
    border: none;
    resize: none;
    color: #fff;
    font-family: Roboto, sans-serif;
    width: calc(100% - 32px - 28px);
    display: inline-block;
  }

  .input {
    position: relative;
  }

  .suggestions {
    position: absolute;
    width: calc(100% - 32px - 48px + 1.8rem);
    margin: 0 auto;
    left: 0;
    right: 0;
    bottom: calc(100% - 0.4rem);
    background: #101112;
    border-top-left-radius: 5px;
    border-top-right-radius: 5px;
  }

  .suggestion {
    padding: 0.5em 1em;
    cursor: pointer;
  }

  .suggestion:hover, .suggestion.selected {
    background: #4b4f52;
  }

  .suggestion-icon {
    display: inline-block;
    height: 1.2em;
    width: 1.2em;
    vertical-align: text-bottom;
    margin-right: 0.5em;
  }
  .suggestion-icon img {
    height: 100%;
    width: 100%;
  }
  .suggestion-name {
    display: inline-block;
  }

  .channel-textarea.suggesting {
    border-top-left-radius: 0;
    border-top-right-radius: 0;
  }

  .picker {
    position: absolute;
    bottom: 100%;
    height: 50vh;
    max-height: 500px;
    border-radius: 5px;
    width: calc(320px + 16px + 16px);
    right: 27px;
    color: #000;
    background: #333;
    border: solid 1.4px #202020;
    box-shadow: 0 2px 3px #11111110;
  }

  @media (max-width: 700px) {
    .picker {
      width: 100vw;
      right: 0;
      left: 0;
      top: 0;
      position: initial;
      border-radius: 0;
      border: none;
      background: #2f3336;
      box-shadow: none;
    }

    .channel-textarea {
      border-radius: 0;
      width: calc(100vw - 30px);
      margin: 0;
      font-size: 0.5em;
    }

    .channel-textarea-native {
      width: calc(100% - 32px - 28px + 4px);
    }
    /* This appears to cause browsers to bork rendering? */
    /* .input.picker-open {
         height: 100%;
       } */
  }
</style>
